All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2015
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compatibility's with Git. In case Git ever changes its licensing terms,
12 # which is admittedly extremely unlikely to the point of being impossible,
13 # this software will most likely follow suit.
15 # This should always be the first line of code to facilitate debugging
16 [ -n "$VCSH_DEBUG" ] && set -vx
19 # If '.git-HEAD' is appended to the version, you are seeing an unreleased
20 # version of vcsh; the master branch is supposed to be clean at all times
21 # so you can most likely just use it nonetheless
26 echo "$SELF: fatal: $1" >&2
31 # We need to run getops as soon as possible so we catch -d and other
32 # options that will modify our behaviour.
33 # Commands are handled at the end of this script.
34 while getopts "c:dv" flag; do
35 if [ x"$1" = x'-d' ] || [ x"$1" = x'--debug' ]; then
40 elif [ x"$1" = x'-v' ]; then
42 echo "verbose mode on"
44 elif [ x"$1" = x'-c' ]; then
45 VCSH_OPTION_CONFIG=$OPTARG
51 # Source file even if it's in $PWD and does not have any slashes in it
59 # Read configuration and set defaults if anything's not set
60 [ -n "$VCSH_DEBUG" ] && set -vx
61 : ${XDG_CONFIG_HOME:="$HOME/.config"}
63 # Read configuration files if there are any
64 [ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
65 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
66 if [ -n "$VCSH_OPTION_CONFIG" ]; then
67 # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
68 if [ -r "$VCSH_OPTION_CONFIG" ]; then
69 source_all "$VCSH_OPTION_CONFIG"
71 fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
74 [ -n "$VCSH_DEBUG" ] && set -vx
77 : ${VCSH_REPO_D:="$XDG_CONFIG_HOME/vcsh/repo.d"}
78 : ${VCSH_HOOK_D:="$XDG_CONFIG_HOME/vcsh/hooks-enabled"}
79 : ${VCSH_OVERLAY_D:="$XDG_CONFIG_HOME/vcsh/overlays-enabled"}
80 : ${VCSH_BASE:="$HOME"}
81 : ${VCSH_GITIGNORE:=exact}
82 : ${VCSH_GITATTRIBUTES:=none}
83 : ${VCSH_WORKTREE:=absolute}
85 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
86 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
89 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ] && [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
90 fatal "'\$VCSH_WORKTREE' must equal 'absolute', or 'relative'" 1
95 echo "usage: $SELF <options> <command>
100 -v Enable verbose mode
103 clone [-b <branch>] \\
105 [<repo>] Clone from an existing repository
106 commit Commit in all repositories
107 delete <repo> Delete an existing repository
108 enter <repo> Enter repository; spawn new instance of \$SHELL
110 <git command> Execute a command for every repository
111 help Display this help text
112 init <repo> Initialize a new repository
113 list List all repositories
115 [<repo>] List all files tracked all or one repositories
118 [<repo>] List all files not tracked by all or one repositories
119 pull Pull from all vcsh remotes
120 push Push to vcsh remotes
122 <newname> Rename repository
124 <command> Use this repository
126 [--terse] [<repo>] Show statuses of all/one vcsh repositories
127 upgrade <repo> Upgrade repository to currently recommended settings
128 version Print version information
129 which <substring> Find substring in name of any tracked file
131 <repo> Write .gitignore.d/<repo> via git ls-files
133 <repo> <git command> Shortcut to run git commands directly
134 <repo> Shortcut to enter repository" >&2
138 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
142 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
146 echo "$SELF: error: $1" >&2
150 echo "$SELF: info: $1"
156 git remote add origin "$GIT_REMOTE"
157 git checkout -b "$VCSH_BRANCH" || return $?
158 git config branch."$VCSH_BRANCH".remote origin
159 git config branch."$VCSH_BRANCH".merge refs/heads/"$VCSH_BRANCH"
160 if [ $(git ls-remote origin "$VCSH_BRANCH" 2> /dev/null | wc -l ) -lt 1 ]; then
161 info "remote is empty, not merging anything.
162 You should add files to your new repository."
165 git fetch origin "$VCSH_BRANCH"
167 git ls-tree -r --name-only origin/"$VCSH_BRANCH" | (while read object; do
169 error "'$object' exists." &&
172 [ x"$VCSH_CONFLICT" = x'1' ]) &&
173 fatal "will stop after fetching and not try to merge!
174 Once this situation has been resolved, run 'vcsh $VCSH_REPO_NAME pull' to finish cloning." 17
175 git -c merge.ff=true merge origin/"$VCSH_BRANCH"
179 hook post-clone-retired
184 for VCSH_REPO_NAME in $(list); do
185 echo "$VCSH_REPO_NAME: "
186 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
188 git commit --untracked-files=no --quiet
189 VCSH_COMMAND_RETURN_CODE=$?
196 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
198 info "This operation WILL DESTROY DATA!"
199 files=$(git ls-files)
200 echo "These files will be deleted:
204 AGAIN, THIS WILL DELETE YOUR DATA!
205 To continue, type 'Yes, do as I say'"
207 [ "x$answer" = 'xYes, do as I say' ] || exit 16
208 for file in $files; do
209 rm -f $file || info "could not delete '$file', continuing with deletion"
211 rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
224 # We default to prefixing `git` to all commands passed to foreach, but
225 # allow running in general context with -g
227 while getopts "g" flag; do
228 if [ x"$1" = x'-g' ]; then
233 for VCSH_REPO_NAME in $(list); do
234 echo "$VCSH_REPO_NAME:"
235 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
243 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
247 for hook in "$VCSH_HOOK_D/$1"* "$VCSH_HOOK_D/$VCSH_REPO_NAME.$1"*; do
248 [ -x "$hook" ] || continue
249 verbose "executing '$hook'"
256 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
257 mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
258 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
259 git init --shared=0600
265 for repo in "$VCSH_REPO_D"/*.git; do
266 [ -d "$repo" ] && [ -r "$repo" ] && echo "$(basename "$repo" .git)"
271 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
276 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
277 if [ -n "$VCSH_REPO_NAME" ]; then
278 get_files | list_tracked_helper
280 for VCSH_REPO_NAME in $(list); do
282 done | list_tracked_helper
286 list_tracked_helper() {
287 sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | sed 's/[,\&]/\\&/g')," | sort -u
295 command -v 'comm' >/dev/null 2>&1 || fatal "Could not find 'comm'"
297 temp_file_others=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
298 temp_file_untracked=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
299 temp_file_untracked_copy=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
301 # Hack in support for `vcsh list-untracked -r`...
302 exclude_standard_opt='--exclude-standard'
303 directory_opt="--directory"
305 while getopts "ar" flag; do
306 if [ x"$1" = x'-a' ]; then
307 unset exclude_standard_opt
308 elif [ x"$1" = x'-r' ]; then
313 # ...and parse for a potential parameter afterwards. As we shifted things out of $* in during getops, we need to look at $1
314 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
316 if [ -n "$VCSH_REPO_NAME" ]; then
317 list_untracked_helper $VCSH_REPO_NAME
319 for VCSH_REPO_NAME in $(list); do
320 list_untracked_helper $VCSH_REPO_NAME
323 cat $temp_file_untracked
325 unset directory_opt directory_component
326 rm -f $temp_file_others $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not delete temp files'
329 list_untracked_helper() {
330 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
331 git ls-files --others $exclude_standard_opt "$directory_opt" | (
334 directory_component=${line%%/*}
335 [ -d "$directory_component" ] && printf '%s/\n' "$directory_component"
337 ) | sort -u > $temp_file_others
338 if [ -z "$ran_once" ]; then
340 cp $temp_file_others $temp_file_untracked || fatal 'Could not copy temp file'
342 cp $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not copy temp file'
343 comm -12 $temp_file_others $temp_file_untracked_copy > $temp_file_untracked
348 for VCSH_REPO_NAME in $(list); do
349 printf '%s: ' "$VCSH_REPO_NAME"
350 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
353 VCSH_COMMAND_RETURN_CODE=$?
361 for VCSH_REPO_NAME in $(list); do
362 printf '%s: ' "$VCSH_REPO_NAME"
363 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
366 VCSH_COMMAND_RETURN_CODE=$?
378 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
379 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
381 # Now that the repository has been renamed, we need to fix up its configuration
382 # Overwrite old name..
384 VCSH_REPO_NAME=$VCSH_REPO_NAME_NEW
385 # ..and clobber all old configuration
393 VCSH_COMMAND_RETURN_CODE=$?
399 COLORING="-c color.status=always"
401 if [ -n "$VCSH_REPO_NAME" ]; then
402 status_helper $VCSH_REPO_NAME
404 for VCSH_REPO_NAME in $(list); do
405 STATUS=$(status_helper $VCSH_REPO_NAME "$COLORING")
406 [ -n "$STATUS" -o -z "$VCSH_STATUS_TERSE" ] && echo "$VCSH_REPO_NAME:"
407 [ -n "$STATUS" ] && echo "$STATUS"
408 [ -z "$VCSH_STATUS_TERSE" ] && echo
414 GIT_DIR=$VCSH_REPO_D/$1.git; export GIT_DIR
417 remote_tracking_branch=$(git rev-parse --abbrev-ref --symbolic-full-name @{u} 2> /dev/null) && {
418 commits_behind=$(git log ..${remote_tracking_branch} --oneline | wc -l)
419 commits_ahead=$(git log ${remote_tracking_branch}.. --oneline | wc -l)
420 [ ${commits_behind} -ne 0 ] && echo "Behind $remote_tracking_branch by $commits_behind commits"
421 [ ${commits_ahead} -ne 0 ] && echo "Ahead of $remote_tracking_branch by $commits_ahead commits"
423 git ${VCSH_GIT_OPTIONS} status --short --untracked-files='no'
424 VCSH_COMMAND_RETURN_CODE=$?
429 # fake-bare repositories are not bare, actually. Set this to false
430 # because otherwise Git complains "fatal: core.bare and core.worktree
432 git config core.bare false
433 # core.worktree may be absolute or relative to $GIT_DIR, depending on
435 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ]; then
436 git config core.worktree "$(cd "$GIT_DIR" && GIT_WORK_TREE=$VCSH_BASE git rev-parse --show-cdup)"
437 elif [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
438 git config core.worktree "$VCSH_BASE"
440 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
441 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && git config core.attributesfile ".gitattributes.d/$VCSH_REPO_NAME"
442 git config vcsh.vcsh 'true'
444 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
445 [ -e "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME"
451 VCSH_DIRECTORY=$VCSH_REPO_NAME; export VCSH_DIRECTORY
455 output=$(for VCSH_REPO_NAME in $(list); do
456 get_files | grep -- "$VCSH_COMMAND_PARAMETER" | sed "s/^/$VCSH_REPO_NAME: /"
458 if [ -z "$output" ]; then
459 fatal "'$VCSH_COMMAND_PARAMETER' does not exist" 1
466 # Don't do anything if the user does not want to write gitignore
467 if [ "x$VCSH_GITIGNORE" = 'xnone' ]; then
468 info "Not writing gitignore as '\$VCSH_GITIGNORE' is set to 'none'"
473 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
476 gitignores=$(for file in $(git ls-files); do
478 echo "$file"; new=${file%/*}
479 [ x"$file" = x"$new" ] && break
484 # Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
485 # Using a template makes GNU mktemp default to $PWD and not #TMPDIR for tempfile location
486 # To make every OS happy, set full path explicitly
487 tempfile=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal "could not create tempfile: '${tempfile}'" 51
489 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
490 for gitignore in $gitignores; do
491 echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
492 if [ "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ -d "$gitignore" ]; then
493 { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
497 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
498 rm -f "$tempfile" || error "could not delete '$tempfile'"
501 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
502 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
503 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
504 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
506 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
507 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
512 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
513 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
516 VCSH_COMMAND=$1; export VCSH_COMMAND
518 case $VCSH_COMMAND in
519 clon|clo|cl) VCSH_COMMAND=clone;;
520 commi|comm|com|co) VCSH_COMMAND=commit;;
521 delet|dele|del|de) VCSH_COMMAND=delete;;
522 ente|ent|en) VCSH_COMMAND=enter;;
523 hel|he) VCSH_COMMAND=help;;
524 ini|in) VCSH_COMMAND=init;;
525 pul) VCSH_COMMAND=pull;;
526 pus) VCSH_COMMAND=push;;
527 renam|rena|ren|re) VCSH_COMMAND=rename;;
528 ru) VCSH_COMMAND=run;;
529 statu|stat|sta|st) VCSH_COMMAND=status;;
530 upgrad|upgra|upgr|up) VCSH_COMMAND=upgrade;;
531 versio|versi|vers|ver|ve) VCSH_COMMAND=version;;
532 which|whi|wh) VCSH_COMMAND=which;;
533 write|writ|wri|wr) VCSH_COMMAND=write-gitignore;;
536 if [ x"$VCSH_COMMAND" = x'clone' ]; then
538 if [ "$2" = -b ]; then
543 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
545 [ -n "$VCSH_BRANCH" ] || if [ "$3" = -b ]; then
552 [ -z "$VCSH_BRANCH" ] && [ "$4" = -b ] && VCSH_BRANCH=$5
554 VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
556 [ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
557 export VCSH_REPO_NAME
558 [ -n "$VCSH_BRANCH" ] || VCSH_BRANCH=master
559 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
560 elif [ "$VCSH_COMMAND" = 'version' ]; then
561 echo "$SELF $VERSION"
564 elif [ x"$VCSH_COMMAND" = x'which' ]; then
565 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a filename" 1
566 [ -n "$3" ] && fatal "$VCSH_COMMAND: too many parameters" 1
567 VCSH_COMMAND_PARAMETER=$2; export VCSH_COMMAND_PARAMETER
568 elif [ x"$VCSH_COMMAND" = x'delete' ] ||
569 [ x"$VCSH_COMMAND" = x'enter' ] ||
570 [ x"$VCSH_COMMAND" = x'init' ] ||
571 [ x"$VCSH_COMMAND" = x'list-tracked-by' ] ||
572 [ x"$VCSH_COMMAND" = x'rename' ] ||
573 [ x"$VCSH_COMMAND" = x'run' ] ||
574 [ x"$VCSH_COMMAND" = x'upgrade' ] ||
575 [ x"$VCSH_COMMAND" = x'write-gitignore' ]; then
576 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify repository to work on" 1
577 [ x"$VCSH_COMMAND" = x'rename' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a target name" 1
578 [ x"$VCSH_COMMAND" = x'run' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a command" 1
579 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
580 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
581 [ x"$VCSH_COMMAND" = x'rename' ] && { VCSH_REPO_NAME_NEW=$3; export VCSH_REPO_NAME_NEW;
582 GIT_DIR_NEW=$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git; export GIT_DIR_NEW; }
583 [ x"$VCSH_COMMAND" = x'run' ] && shift 2
584 elif [ x"$VCSH_COMMAND" = x'foreach' ]; then
585 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a command" 1
587 elif [ x"$VCSH_COMMAND" = x'commit' ] ||
588 [ x"$VCSH_COMMAND" = x'list' ] ||
589 [ x"$VCSH_COMMAND" = x'list-tracked' ] ||
590 [ x"$VCSH_COMMAND" = x'list-untracked' ] ||
591 [ x"$VCSH_COMMAND" = x'pull' ] ||
592 [ x"$VCSH_COMMAND" = x'push' ]; then
594 elif [ x"$VCSH_COMMAND" = x'status' ]; then
595 if [ x"$2" = x'--terse' ]; then
596 VCSH_STATUS_TERSE=1; export VCSH_STATUS_TERSE
599 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
600 elif [ -n "$2" ]; then
601 VCSH_COMMAND='run'; export VCSH_COMMAND
602 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
603 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
604 [ -d "$GIT_DIR" ] || { help; exit 1; }
607 elif [ -n "$VCSH_COMMAND" ]; then
608 VCSH_COMMAND='enter'; export VCSH_COMMAND
609 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
610 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
611 [ -d "$GIT_DIR" ] || { help; exit 1; }
613 # $1 is empty, or 'help'
617 # Did we receive a directory instead of a name?
618 # Mangle the input to fit normal operation.
619 if echo "$VCSH_REPO_NAME" | grep -q '/'; then
620 GIT_DIR=$VCSH_REPO_NAME; export GIT_DIR
621 VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git); export VCSH_REPO_NAME
626 if [ ! -d "$check_directory" ]; then
627 if [ -e "$check_directory" ]; then
628 fatal "'$check_directory' exists but is not a directory" 13
630 verbose "attempting to create '$check_directory'"
631 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
636 check_dir "$VCSH_REPO_D"
637 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
638 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && check_dir "$VCSH_BASE/.gitattributes.d"
640 verbose "$VCSH_COMMAND begin"
641 VCSH_COMMAND=$(echo "$VCSH_COMMAND" | sed 's/-/_/g'); export VCSH_COMMAND
643 # Source repo-specific configuration file
644 [ -r "$XDG_CONFIG_HOME/vcsh/config.d/$VCSH_REPO_NAME" ] && . "$XDG_CONFIG_HOME/vcsh/config.d/$VCSH_REPO_NAME"
646 # source overlay functions
647 for overlay in "$VCSH_OVERLAY_D/$VCSH_COMMAND"* "$VCSH_OVERLAY_D/$VCSH_REPO_NAME.$VCSH_COMMAND"*; do
648 [ -r "$overlay" ] || continue
649 info "sourcing '$overlay'"
656 verbose "$VCSH_COMMAND end, exiting"
657 exit $VCSH_COMMAND_RETURN_CODE